
FGL2P = fgl2p
FGLPP = fglcomp
#FGL2P = fgl2p
FGLFORM = fglform

#----------------

.SUFFIXES: .4gl .42m .per .42f .42r .4go .frm

.4gl.42m:
	$(FGLPP) -c -W all $*.4gl

.per.42f:
	$(FGLFORM) -s -M $*.per

#----------------

4GLOBJ = 42m
FRMOBJ = 42f
4GLRUN = 42r
4GLLIB = 42x

ifndef GSRCS
GSRCS=$(wildcard *.4gl)
endif

ifndef GOBJS
GOBJS=$(patsubst %.4gl,%.42m,$(GSRCS))
endif

ifndef FSRCS
FSRCS=$(wildcard *.per)
endif

ifndef FOBJS
FOBJS=$(patsubst %.per,%.42f,$(FSRCS))
endif


ifdef SUBDIRS

all:: subdirs $(PRG1) $(PRG2) $(PRG3) $(PRG4) $(PRG5) $(PRG6) \
							$(PRG7) $(PRG8) $(PRG9) $(PRG10) $(PRG11) $(PRG12) $(PRGOTH) \
			allforms


subdirs::
	@for i in $(SUBDIRS) ;\
	do \
	echo "making" subdirs "in $$i...";\
	$(MAKE) -C $$i $(MFLAGS) all || exit; \
	done

else

all:: $(PRG1) $(PRG2) $(PRG3) $(PRG4) $(PRG5) $(PRG6) \
			$(PRG7) $(PRG8) $(PRG9) $(PRG10) $(PRG11) $(PRG12) $(PRGOTH) \
			allforms

endif

allforms:: $(FOBJS)
	@echo "All Forms build finished."

allmods:: $(GOBJS)
	@echo "All 4gls build finished."

$(genlib): $(GENLIBOBJ)
	$(FGL2P) -o $@ $^

$(PRG1): $(fgl_obj1) $(fgl_frm1) $(genlib) $(lib1)
	$(FGL2P) -o $@ $(fgl_obj1) $(genlib) $(lib1)

$(PRG2): $(fgl_obj2) $(fgl_frm2) $(genlib) $(lib2)
	$(FGL2P) -o $@ $(fgl_obj2) $(genlib) $(lib2)

$(PRG3): $(fgl_obj3) $(fgl_frm3) $(genlib) $(lib3)
	$(FGL2P) -o $@ $(fgl_obj3) $(genlib) $(lib3)

$(PRG4): $(fgl_obj4) $(fgl_frm4) $(genlib) $(lib4)
	$(FGL2P) -o $@ $(fgl_obj4) $(genlib) $(lib4)

$(PRG5): $(fgl_obj5) $(fgl_frm5) $(genlib) $(lib5)
	$(FGL2P) -o $@ $(fgl_obj5) $(genlib) $(lib5)

$(PRG6): $(fgl_obj6) $(fgl_frm6) $(genlib) $(lib6)
	$(FGL2P) -o $@ $(fgl_obj6) $(genlib) $(lib6)

$(PRG7): $(fgl_obj7) $(fgl_frm7) $(genlib) $(lib7)
	$(FGL2P) -o $@ $(fgl_obj7) $(genlib) $(lib7)

$(PRG8): $(fgl_obj8) $(fgl_frm8) $(genlib) $(lib8)
	$(FGL2P) -o $@ $(fgl_obj8) $(genlib) $(lib8)

$(PRG9): $(fgl_obj9) $(fgl_frm9) $(genlib) $(lib9)
	$(FGL2P) -o $@ $(fgl_obj9) $(genlib) $(lib9)

$(PRG10): $(fgl_obj10) $(fgl_frm10) $(genlib) $(lib10)
	$(FGL2P) -o $@ $(fgl_obj10) $(genlib) $(lib10)

$(PRG11): $(fgl_obj11) $(fgl_frm11) $(genlib) $(lib11)
	$(FGL2P) -o $@ $(fgl_obj11) $(genlib) $(lib11)

$(PRG12): $(fgl_obj12) $(fgl_frm12) $(genlib) $(lib12)
	$(FGL2P) -o $@ $(fgl_obj12) $(genlib) $(lib12)

run: $(PRG1)
	$(FGLRUN) $(PRG1) $(ARG1) $(ARG2) $(ARG3)

run2: $(PRG2)
	$(FGLRUN) $(PRG2)

run3: $(PRG3)
	$(FGLRUN) $(PRG3)

run4: $(PRG4)
	$(FGLRUN) $(PRG4)

clean:
	find . -name \*.42? -exec rm {} \;

